Require Import ZArith.
Require Import ZArith.Znumtheory.

Open Scope Z_scope.

Definition isGCD(a b d: Z): Prop :=
  (d | a) /\ (d | b) /\
  (forall c: Z, (c | a) -> (c | b) -> (c | d)).

Lemma gcd_equiv: forall a b d: Z, Zis_gcd a b d <-> isGCD a b d.
Proof.
intros.
split.
intro.
unfold isGCD.
split.
apply H.
split.
apply H.
intro.
apply H.
unfold isGCD.
intros.
apply Zis_gcd_intro.
apply H.
apply H.
apply H.
Qed.

(*
Lemma div_minus_l1: forall a b c: Z, (b > c) -> (a | (b - c)) ->
                   (a | b) -> (a | c).
Proof.
intros.
unfold Z.divide in H0.
unfold Z.divide in H1.
unfold Z.divide.
elim H0.
elim H1.
intros.
exists (x-x0).
rewrite -> (Zmult_minus_distr_r x x0 a).
rewrite <- H2.
apply (Zplus_minus_eq b (x0*a) c).
rewrite <- H3.
assert (c + (-c) = 0).
rewrite -> (Zminus_diag_reverse c).
reflexivity.
assert (b - c = b + (-c)).
apply (Zplus_minus_eq b c (b+(-c))).
rewrite <- (Zplus_assoc_reverse c b (-c)).
rewrite -> (Z.add_comm c b).
rewrite -> (Zplus_assoc_reverse b c (-c)).
rewrite -> H4.
rewrite <- (Zplus_0_r_reverse b).
reflexivity.
rewrite -> H5.
rewrite -> (Zplus_assoc_reverse b (-c) c).
rewrite -> (Z.add_comm (-c) c).
rewrite -> H4.
rewrite <- (Zplus_0_r_reverse b).
reflexivity.
Qed.
*)

Lemma div_minus_l: forall a b c: Z, (b > c) -> (a | (b - c)) ->
                   (a | c) -> (a | b).
Proof.
intros.
unfold Z.divide in H0.
unfold Z.divide in H1.
unfold Z.divide.
elim H0.
elim H1.
intros.
exists (x+x0).
rewrite -> (Zmult_plus_distr_l x x0 a).
rewrite <- H2.
rewrite <- H3.
assert (c + (-c) = 0).
rewrite -> (Zminus_diag_reverse c).
reflexivity.
assert (b - c = b + (-c)).
apply (Zplus_minus_eq b c (b+(-c))).
rewrite <- (Zplus_assoc_reverse c b (-c)).
rewrite -> (Z.add_comm c b).
rewrite -> (Zplus_assoc_reverse b c (-c)).
rewrite -> H4.
rewrite <- (Zplus_0_r_reverse b).
reflexivity.
rewrite -> H5.
rewrite <- (Zplus_assoc_reverse c b (-c)).
rewrite -> (Z.add_comm c b).
rewrite -> (Zplus_assoc_reverse b c (-c)).
rewrite -> H4.
rewrite <- (Zplus_0_r_reverse b).
reflexivity.
Qed.

Lemma div_minus_r: forall a b c: Z, (a | b) -> (a | c) ->
                   (b > c) -> (a | (b - c)).
Proof.
intros.
unfold Z.divide in H.
unfold Z.divide in H0.
unfold Z.divide.
elim H.
elim H0.
intros.
rewrite -> H2.
rewrite -> H3.
rewrite <- (Zmult_minus_distr_r x0 x a).
exists (x0-x).
reflexivity.
Qed.

Lemma gcd_refl: forall a: Z, isGCD a a a.
Proof.
intro.
unfold isGCD.
split.
unfold Z.divide.
exists 1.
rewrite <- (Z.mul_1_l a) at 1.
reflexivity.
split.
unfold Z.divide.
exists 1.
rewrite <- (Z.mul_1_l a) at 1.
reflexivity.
intros.
assumption.
Qed.

Lemma gcd_swap: forall a b d: Z, isGCD a b d -> isGCD b a d.
Proof.
intros.
unfold isGCD.
unfold isGCD in H.
split.
apply H.
split.
apply H.
intro.
assert (forall c : Z, (c | a) -> (c | b) -> (c | d)).
apply H.
intros.
apply H0.
assumption.
assumption.
Qed.


Lemma gcd_minus: forall a b d: Z, isGCD a b d -> 
                 (a > b) -> isGCD (a-b) b d.
Proof.
unfold isGCD.
intros.
split.
apply (div_minus_r d a b).
apply H.
apply H.
assumption.
split.
apply H.
intros.
apply H.
apply (div_minus_l c a b).
assumption.
assumption.
assumption.
assumption.
Qed.















