/*@ requires n >= 1 && \valid(a+(0..n-1));
    requires \forall integer i; 0 <= i < n-1 ==> a[i] <= a[i+1];
    ensures \forall integer i; 0 <= i < n-1 ==> a[i] <= a[i+1];
    assigns a[0..n-1];
*/ 
void sub1 (int* a, int n)
{ int i;
  
  //@ assert \forall integer j; 0 <= j < n-1 ==> a[j] <= a[j+1];
  /*@
      loop assigns i, a[0..n-1];
      loop invariant -1 <= i <= n-1;
      loop invariant 0 <= i < n-1 ==> a[i]-1 <= a[i+1];
      loop invariant 
        \forall integer j; i < j < n-1 ==> a[j] <= a[j+1];
      loop invariant 
        \forall integer k; 0 <= k < i ==> a[k] <= a[k+1];
  */
  for (i=n-1; i>=0; i--)
    a[i]--;
} 
