/*@ predicate divides{L}(integer a, integer b) =
  @   \exists integer q; a*q == b;
  @
  @ lemma divMinusL: \forall integer a,b,c; (b > c) ==> divides(a,b-c) ==>
  @                  divides(a,c) ==> divides(a,b);
  @
  @ lemma divMinusR: \forall integer a,b,c; (b > c) ==> divides(a,b) ==>
  @                  divides(a,c) ==> divides(a,b-c);
  @
  @ predicate isGCD{L}(integer a, integer b, integer d) =
  @   divides(d,a) && divides(d,b) &&
  @   \forall integer c; divides(c,a) && divides(c,b) ==> divides(c,d);
  @*/

/*@ requires 0 < m && 0 < n;
  @ assigns \nothing;
  @ ensures (0 < \result) && isGCD(\old(m),\old(n),\result);
  @*/
int originalEuclid (int m, int n) {
  int x,y,tmp;
  
  x = m;
  y = n;
  /*@ loop invariant 0<x && 0<y &&
    @                \forall integer a; isGCD(x,y,a) <==> isGCD(m,n,a);
    @ loop assigns x, y, tmp;
    @*/
  while (x!=y) {
    if (x < y) {
      tmp = x;
      x = y;
      y = tmp;
    }
    x = x - y;
  }
  return x;
}
